- [HTTP request](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.request_body)
  - [JSON representation](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.response_body)
  - [JSON representation](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.SearchDeveloperMetadataResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#body.aspect)
- [MatchedDeveloperMetadata](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#MatchedDeveloperMetadata)
  - [JSON representation](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#MatchedDeveloperMetadata.SCHEMA_REPRESENTATION)
- [Try it!](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#try-it)

Returns all developer metadata matching the specified `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter`. For more information, see [Read, write, and search metadata](https://developers.google.com/workspace/sheets/api/guides/metadata).

If the provided `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter` represents a `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter#DeveloperMetadataLookup` object, this will return all DeveloperMetadata entries selected by it. If the `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter` represents a location in a spreadsheet, this will return all developer metadata associated with locations intersecting that region.

### HTTP request

`POST https://sheets.googleapis.com/v4/spreadsheets/{spreadsheetId}/developerMetadata:search`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `spreadsheetId` | `string` The ID of the spreadsheet to retrieve metadata from. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "dataFilters": [ { object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter`) } ] } ``` |

| Fields ||
|---|---|
| `dataFilters[]` | ``object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter`)`` The data filters describing the criteria used to determine which DeveloperMetadata entries to return. DeveloperMetadata matching any of the specified filters are included in the response. |

### Response body

A reply to a developer metadata search request.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "matchedDeveloperMetadata": [ { object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#MatchedDeveloperMetadata`) } ] } ``` |

| Fields ||
|---|---|
| `matchedDeveloperMetadata[]` | ``object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata/search#MatchedDeveloperMetadata`)`` The metadata matching the criteria of the search request. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/drive`
- `https://www.googleapis.com/auth/drive.file`
- `https://www.googleapis.com/auth/spreadsheets`

For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).

## MatchedDeveloperMetadata

A developer metadata entry and the data filters specified in the original request that matched it.

| JSON representation |
|---|
| ``` { "developerMetadata": { object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata#DeveloperMetadata`) }, "dataFilters": [ { object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter`) } ] } ``` |

| Fields ||
|---|---|
| `developerMetadata` | ``object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.developerMetadata#DeveloperMetadata`)`` The developer metadata matching the specified filters. |
| `dataFilters[]` | ``object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DataFilter`)`` All filters matching the returned developer metadata. |